/*    
       This software may be used and distributed according to the terms of
       the GNU General Public License (GPL), incorporated herein by
       reference.  Drivers based on this skeleton fall under the GPL and
       must retain the authorship (implicit copyright) notice.
 
       This program is distributed in the hope that it will be useful, but
       WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
       General Public License for more details.
 */
package cricketdaemon.module;

import cricketdaemon.reader.Beacon;
import java.util.*;

public abstract class Data
{
    public Beacon beacon;
    public Long timeStamp;      // cpu time 
    public Long hwTimeStamp;    // hw time that generated this data
    public Long timeGenerated;  // time this data was generated
    
    public Data()
    {
	if(!(this instanceof Beacon)) {
	    System.out.println("ModuleThread::Data() DefaultConstructor to be used by Beacon class only!");
	    System.exit(1);
	}
    }
    
    public Data(Beacon b)
    {
	beacon      = b;
	timeStamp   = beacon.timeStamp;
	hwTimeStamp = beacon.hwTimeStamp;
	timeGenerated = new Long(System.currentTimeMillis());
    }
    
    public abstract void process(Object handler, BitSet fieldMask);
    public abstract String toString();
}

